#include <18F1220.h>
#device ICD=TRUE
#device adc=10

#FUSES NOWDT                 	//No Watch Dog Timer
#FUSES WDT128                	//Watch Dog Timer uses 1:128 Postscale
#FUSES HS                    	//High speed Osc (> 4mhz)
#FUSES FCMEN                 	//Fail-safe clock monitor enabled
#FUSES BROWNOUT              	//Reset when brownout detected
//#FUSES NOBROWNOUT
#FUSES BORV27                	//Brownout reset at 2.7V
//#FUSES NOPUT                 	//No Power Up Timer
#FUSES PUT                   	//Power Up Timer
#FUSES NOCPD                 	//No EE protection
#FUSES STVREN                	//Stack full/underflow will cause reset
#FUSES DEBUG                 	//Debug mode for use with ICD
#FUSES NOLVP                 	//No low voltage prgming, B3(PIC16) or B5(PIC18) used for I/O
#FUSES NOWRT                 	//Program memory not write protected
#FUSES NOWRTD                	//Data EEPROM not write protected
#FUSES NOWRTC                	//configuration not registers write protected
#FUSES IESO                  	//Internal External Switch Over mode enabled
#FUSES NOEBTR                	//Memory not protected from table reads
#FUSES NOEBTRB               	//Boot block not protected from table reads
#FUSES MCLR                  	//Master Clear pin enabled
#FUSES NOPROTECT             	//Code not protected from reading
#FUSES NOCPB                 	//No Boot Block code protection
#FUSES NOWRTB                	//Boot block not write protected

#use delay(clock=20000000,RESTART_WDT)

#define LED_CS_1      PIN_B2
#define LED_CLK_1      PIN_B3
#define LED_DATA_1     PIN_B5
#define TAOS_S2_1   	PIN_A2
#define TAOS_S3_1    PIN_A3
#define TAOS_OUT_1  	PIN_B1
#define IR_LED_1       PIN_A4
#define IR_IN_1        PIN_A1
#define LED_WHITE_1    PIN_B4

#define PUSH_SWITCH    PIN_B0

////////////////////////////////////////////////////////////////////////////
const int FRAME_FREQ = 0x10;
const int PWM_SWEEP_SELECT = 0x20;

const int PWM_SWEEP_LED_R = 0x50;
const int PWM_SWEEP_LED_G = 0x40;
const int PWM_SWEEP_LED_B = 0x30;

const int PWM_DATA_LED_R = 0x80;//LED3 -port3
const int PWM_DATA_LED_G = 0x70;//LED2 -port4
const int PWM_DATA_LED_B = 0x60;//LED1 -port5 

const int PWM_COUNT_LED_R = 0xB0;
const int PWM_COUNT_LED_G = 0xA0;
const int PWM_COUNT_LED_B = 0x90;

const int PWM_SWEEP = 0xC0;
const int RESET = 0xD0;

////////////////////////////////////////////////////////////////////////////
const int UNIT_MAX  = 1;
const int LED_MAX = 15;
const int BISECT_TRIES = 8;
const int DARK_OFFSET = 6;
const int MAX_COLOR_VALUE = 255;

int reds[UNIT_MAX];
int greens[UNIT_MAX];
int blues[UNIT_MAX];

int red_leds[UNIT_MAX];
int green_leds[UNIT_MAX];
int blue_leds[UNIT_MAX];
int red_leds_pre[UNIT_MAX];
int green_leds_pre[UNIT_MAX];
int blue_leds_pre[UNIT_MAX];

int red_references[UNIT_MAX];
int green_references[UNIT_MAX];
int blue_references[UNIT_MAX];

int init_flags[UNIT_MAX];
int release_flags[UNIT_MAX];

//int led_demo_reverses[UNIT_MAX];

long x = 0;
long count_read = 0;
