////////////////////////////////////////////////////////////////////
/// Controlling fullcolor LED                               ////////
////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
//converting color resolution suited for LED
void get_colors_led(int port){
   red_leds[port] = reds[port] / 16;
   green_leds[port] = greens[port] / 16;
   blue_leds[port] = blues[port] / 16;
   return;
}

//////////////////////////////////////////////////////////////////////////////
void send_led_bit(int port, short data_bit){
   switch(port){
      case 0:
         output_low(LED_CLK_1);
         output_bit(LED_DATA_1, data_bit);
         output_high(LED_CLK_1);
         break;
   }
}

void send_led_data(int port, int data){
   signed int i = 0;
   short data_bit = 0;

   switch(port){
      case 0:
         output_high(LED_CS_1);
         for(i=7;i>=0;i--){
            data_bit = bit_test(data,i);
            send_led_bit(port, data_bit);
         }
         output_low(LED_CS_1);
         break;
   }
}

void set_led(int port, int r, int g, int b){

   send_led_data(port, FRAME_FREQ + 0x01);
   send_led_data(port, PWM_SWEEP_SELECT + 0x00);

   send_led_data(port, PWM_DATA_LED_R + r);
   send_led_data(port, PWM_DATA_LED_G + g);
   send_led_data(port, PWM_DATA_LED_B + b);

   send_led_data(port, PWM_SWEEP + 0x0F);
}

